# script for fine-tune model using regression data 


for gen_model in "Llama-2-7b-chat-hf"  "Llama-2-7b-chat-fp16" 
do
    for model_name in "Llama-2-7b-chat-fp16" "Llama-2-7b-chat-hf" "vicuna-7b-v1.5"
    do
        for data_name in "alpaca_dataset" "bt_dataset" "dolly_dataset" 
        do
            for iter in 0 1 2 3
            do
                CUDA_VISIBLE_DEVICES=1,2 torchrun --nproc_per_node 2 ../finetuning.py \
                --batch_size_training 20 --lr 5e-5 \
                --num_epochs 20 \
                --dataset reg_dataset \
                --data_path ../../clean_label/large_ppl_dataset_temp2_topp2/$gen_model/$data_name/$iter.jsonl \
                --enable_fsdp \
                --model_name ../../hf/$model_name --pure_bf16 \
                --fsdp_checkpoint_path ../fsdp/$model_name/reg-epoch=20-temp2_topp2/$gen_model-$data_name/$iter

                python ../inference/checkpoint_converter_fsdp_hf.py \
                -fsdp_checkpoint_path ../fsdp/$model_name/reg-epoch=20-temp2_topp2/$gen_model-$data_name/$iter \
                -consolidated_model_path ../finetuned_models/$model_name/reg-epoch=20-temp2_topp2/$gen_model-$data_name/$iter \
                -HF_model_path_or_name ../../hf/$model_name
            done
        done
    done
done


for gen_model in "Llama-2-7b-chat-hf"  "Llama-2-7b-chat-fp16" 
do
    for model_name in "Llama-2-7b-chat-fp16" "Llama-2-7b-chat-hf" "vicuna-7b-v1.5"
    do
        for data_name in "alpaca_dataset" "bt_dataset" "dolly_dataset" 
        do
            for iter in 0 1 2 3
            do
                CUDA_VISIBLE_DEVICES=1,2 torchrun --nproc_per_node 2 ../finetuning.py \
                --batch_size_training 20 --lr 5e-5 \
                --num_epochs 20 \
                --dataset reg_dataset \
                --data_path ../../clean_label/large_ppl_dataset/$gen_model/$data_name/$iter.jsonl \
                --enable_fsdp \
                --model_name ../../hf/$model_name --pure_bf16 \
                --fsdp_checkpoint_path ../fsdp/$model_name/reg-epoch=20/$gen_model-$data_name/$iter

                python ../inference/checkpoint_converter_fsdp_hf.py \
                -fsdp_checkpoint_path ../fsdp/$model_name/reg-epoch=20/$gen_model-$data_name/$iter \
                -consolidated_model_path ../finetuned_models/$model_name/reg-epoch=20/$gen_model-$data_name/$iter \
                -HF_model_path_or_name ../../hf/$model_name
            done
        done
    done
done


